gtkmm 4.10.0

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gtk::CellRendererSpinner Class Reference
TreeView Classes

Renders a spinning animation in a cell. More...

`#include <gtkmm/cellrendererspinner.h>`

Inheritance diagram for Gtk::CellRendererSpinner:
[legend]

## Public Member Functions
| CellRendererSpinner (CellRendererSpinner && src) noexcept
CellRendererSpinner & | operator= (CellRendererSpinner && src) noexcept
| CellRendererSpinner (const CellRendererSpinner &)=delete
CellRendererSpinner & | operator= (const CellRendererSpinner &)=delete
| ~CellRendererSpinner () noexcept override
GtkCellRendererSpinner * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkCellRendererSpinner * | gobj () const
| Provides access to the underlying C GObject. More...
| CellRendererSpinner ()
Glib::PropertyProxy< bool > | property_active ()
| Default value: `false` More...
Glib::PropertyProxy_ReadOnly< bool > | property_active () const
| Default value: `false` More...
Glib::PropertyProxy< guint > | property_pulse ()
| Pulse of the spinner. More...
Glib::PropertyProxy_ReadOnly< guint > | property_pulse () const
| Pulse of the spinner. More...
Glib::PropertyProxy< Gtk::IconSize > | property_size ()
| The `Gtk::IconSize` value that specifies the size of the rendered spinner. More...
Glib::PropertyProxy_ReadOnly< Gtk::IconSize > | property_size () const
| The `Gtk::IconSize` value that specifies the size of the rendered spinner. More...
Public Member Functions inherited from Gtk::CellRenderer
| CellRenderer (CellRenderer && src) noexcept
CellRenderer & | operator= (CellRenderer && src) noexcept
| CellRenderer (const CellRenderer &)=delete
CellRenderer & | operator= (const CellRenderer &)=delete
| ~CellRenderer () noexcept override
GtkCellRenderer * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkCellRenderer * | gobj () const
| Provides access to the underlying C GObject. More...
SizeRequestMode | get_request_mode () const
| Gets whether the cell renderer prefers a height-for-width layout or a width-for-height layout. More...
void | get_preferred_width (Widget & widget, int & minimum_width, int & natural_width) const
| Retrieves a renderer’s natural size when rendered to widget. More...
void | get_preferred_height_for_width (Widget & widget, int width, int & minimum_height, int & natural_height) const
| Retrieves a cell renderers’s minimum and natural height if it were rendered to widget with the specified width. More...
void | get_preferred_height (Widget & widget, int & minimum_height, int & natural_height) const
| Retrieves a renderer’s natural size when rendered to widget. More...
void | get_preferred_width_for_height (Widget & widget, int height, int & minimum_width, int & natural_width) const
| Retrieves a cell renderers’s minimum and natural width if it were rendered to widget with the specified height. More...
void | get_preferred_size (Widget & widget, Requisition & minimum_size, Requisition & natural_size) const
| Retrieves the minimum and natural size of a cell taking into account the widget’s preference for height-for-width management. More...
Gdk::Rectangle | get_aligned_area (Widget & widget, CellRendererState flags, const Gdk::Rectangle & cell_area) const
| Gets the aligned area used by this CellRenderer inside cell_area. More...
void | snapshot (const Glib::RefPtr< Gtk::Snapshot > & snapshot, Widget & widget, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
| Invokes the virtual render function of the `Gtk::CellRenderer`. More...
bool | activate (const Glib::RefPtr< const Gdk::Event > & event, Widget & widget, const Glib::ustring & path, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
| Passes an activate event to the cell renderer for possible processing. More...
CellEditable * | start_editing (const Glib::RefPtr< const Gdk::Event > & event, Widget & widget, const Glib::ustring & path, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags=CellRendererState(0))
| Starts editing the contents of this cell, through a new `Gtk::CellEditable` widget created by the `Gtk::CellRenderer`Class.start_editing virtual function. More...
void | set_fixed_size (int width, int height)
| Sets the renderer size to be explicit, independent of the properties set. More...
void | get_fixed_size (int & width, int & height) const
| Fills in width and height with the appropriate size of cell. More...
void | set_alignment (float xalign, float yalign)
| Sets the renderer’s alignment within its available space. More...
void | get_alignment (float & xalign, float & yalign) const
| Fills in xalign and yalign with the appropriate values of cell. More...
void | set_padding (int xpad, int ypad)
| Sets the renderer’s padding. More...
void | get_padding (int & xpad, int & ypad) const
| Fills in xpad and ypad with the appropriate values of cell. More...
void | set_visible (bool visible=true)
| Sets the cell renderer’s visibility. More...
bool | get_visible () const
| Returns the cell renderer’s visibility. More...
void | set_sensitive (bool sensitive=true)
| Sets the cell renderer’s sensitivity. More...
bool | get_sensitive () const
| Returns the cell renderer’s sensitivity. More...
bool | is_activatable () const
| Checks whether the cell renderer can do something when activated. More...
void | set_is_expander (bool is_expander=true)
| Sets whether the given `Gtk::CellRenderer` is an expander. More...
bool | get_is_expander () const
| Checks whether the given `Gtk::CellRenderer` is an expander. More...
void | set_is_expanded (bool is_expanded=true)
| Sets whether the given `Gtk::CellRenderer` is expanded. More...
bool | get_is_expanded () const
| Checks whether the given `Gtk::CellRenderer` is expanded. More...
void | stop_editing (bool canceled=false)
| Informs the cell renderer that the editing is stopped. More...
StateFlags | get_state (Widget & widget, CellRendererState cell_state) const
| Translates the cell renderer state to `Gtk::StateFlags`, based on the cell renderer and widget sensitivity, and the given `Gtk::CellRenderer`State. More...
StateFlags | get_state (CellRendererState cell_state) const
| A get_state() convenience overload. More...
Glib::SignalProxy< void()> | signal_editing_canceled ()
Glib::SignalProxy< void(CellEditable *, const Glib::ustring &)> | signal_editing_started ()
Glib::PropertyProxy< CellRendererMode > | property_mode ()
| Default value: Gtk::CellRendererMode::INERT. More...
Glib::PropertyProxy_ReadOnly< CellRendererMode > | property_mode () const
| Default value: Gtk::CellRendererMode::INERT. More...
Glib::PropertyProxy< bool > | property_visible ()
| Default value: `true` More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Default value: `true` More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Default value: `true` More...
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Default value: `true` More...
Glib::PropertyProxy< float > | property_xalign ()
| Default value: 0.5. More...
Glib::PropertyProxy_ReadOnly< float > | property_xalign () const
| Default value: 0.5. More...
Glib::PropertyProxy< float > | property_yalign ()
| Default value: 0.5. More...
Glib::PropertyProxy_ReadOnly< float > | property_yalign () const
| Default value: 0.5. More...
Glib::PropertyProxy< unsigned int > | property_xpad ()
| Default value: 0. More...
Glib::PropertyProxy_ReadOnly< unsigned int > | property_xpad () const
| Default value: 0. More...
Glib::PropertyProxy< unsigned int > | property_ypad ()
| Default value: 0. More...
Glib::PropertyProxy_ReadOnly< unsigned int > | property_ypad () const
| Default value: 0. More...
Glib::PropertyProxy< int > | property_width ()
| Default value: -1. More...
Glib::PropertyProxy_ReadOnly< int > | property_width () const
| Default value: -1. More...
Glib::PropertyProxy< int > | property_height ()
| Default value: -1. More...
Glib::PropertyProxy_ReadOnly< int > | property_height () const
| Default value: -1. More...
Glib::PropertyProxy< bool > | property_is_expander ()
| Default value: `false` More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_expander () const
| Default value: `false` More...
Glib::PropertyProxy< bool > | property_is_expanded ()
| Default value: `false` More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_expanded () const
| Default value: `false` More...
Glib::PropertyProxy_WriteOnly< Glib::ustring > | property_cell_background ()
| Default value: "". More...
Glib::PropertyProxy< Gdk::RGBA > | property_cell_background_rgba ()
| Cell background as a `GdkRGBA` More...
Glib::PropertyProxy_ReadOnly< Gdk::RGBA > | property_cell_background_rgba () const
| Cell background as a `GdkRGBA` More...
Glib::PropertyProxy< bool > | property_cell_background_set ()
| Default value: `false` More...
Glib::PropertyProxy_ReadOnly< bool > | property_cell_background_set () const
| Default value: `false` More...
Glib::PropertyProxy_ReadOnly< bool > | property_editing () const
| Default value: `false` More...
Public Member Functions inherited from Gtk::Object
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::CellRenderer
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Gtk::CellRendererSpinner * | wrap (GtkCellRendererSpinner * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::CellRenderer
Gtk::CellRenderer * | wrap (GtkCellRenderer * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Gtk::CellRenderer
| CellRenderer ()
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | get_preferred_width_vfunc (Widget & widget, int & minimum_width, int & natural_width) const
virtual void | get_preferred_height_for_width_vfunc (Widget & widget, int width, int & minimum_height, int & natural_height) const
virtual void | get_preferred_height_vfunc (Widget & widget, int & minimum_height, int & natural_height) const
virtual void | get_preferred_width_for_height_vfunc (Widget & widget, int height, int & minimum_width, int & natural_width) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > &snapshot, Widget & widget, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
virtual bool | activate_vfunc (const Glib::RefPtr< const Gdk::Event > & event, Widget & widget, const Glib::ustring & path, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
virtual CellEditable * | start_editing_vfunc (const Glib::RefPtr< const Gdk::Event > & event, Widget & widget, const Glib::ustring & path, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
virtual void | on_editing_canceled ()
| This is a default handler for the signal signal_editing_canceled(). More...
virtual void | on_editing_started (CellEditable * editable, const Glib::ustring & path)
| This is a default handler for the signal signal_editing_started(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Detailed Description

Renders a spinning animation in a cell.

A CellRendererSpinner can be used as an alternative to CellRendererProgress for displaying indefinite activity, instead of actual progress.

To start the animation in a cell, set the active property to true and increment the pulse property at regular intervals.

Deprecated:
  4.10: List views use widgets to display their contents. You should use Gtk::Spinner instead.

## Constructor & Destructor Documentation

## ◆ CellRendererSpinner() [1/3]

Gtk::CellRendererSpinner::CellRendererSpinner | ( | CellRendererSpinner && | src | ) |
| noexcept

## ◆ CellRendererSpinner() [2/3]

Gtk::CellRendererSpinner::CellRendererSpinner | ( | const CellRendererSpinner & |  | ) |
| delete

## ◆ ~CellRendererSpinner()

Gtk::CellRendererSpinner::~CellRendererSpinner | ( |  | ) |
| override noexcept

## ◆ CellRendererSpinner() [3/3]

Gtk::CellRendererSpinner::CellRendererSpinner | ( |  | ) |

## Member Function Documentation

## ◆ get_type()

static GType Gtk::CellRendererSpinner::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkCellRendererSpinner* Gtk::CellRendererSpinner::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkCellRendererSpinner* Gtk::CellRendererSpinner::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=() [1/2]

CellRendererSpinner& Gtk::CellRendererSpinner::operator= | ( | CellRendererSpinner && | src | ) |
| noexcept

## ◆ operator=() [2/2]

CellRendererSpinner& Gtk::CellRendererSpinner::operator= | ( | const CellRendererSpinner & |  | ) |
| delete

## ◆ property_active() [1/2]

Glib::PropertyProxy< bool > Gtk::CellRendererSpinner::property_active | ( |  | ) |

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_active() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRendererSpinner::property_active | ( |  | ) | const

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pulse() [1/2]

Glib::PropertyProxy< guint > Gtk::CellRendererSpinner::property_pulse | ( |  | ) |

Pulse of the spinner.

Increment this value to draw the next frame of the spinner animation. Usually, you would update this value in a timeout.

By default, the `Gtk::Spinner` widget draws one full cycle of the animation, consisting of 12 frames, in 750 milliseconds.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_pulse() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gtk::CellRendererSpinner::property_pulse | ( |  | ) | const

Pulse of the spinner.

Increment this value to draw the next frame of the spinner animation. Usually, you would update this value in a timeout.

By default, the `Gtk::Spinner` widget draws one full cycle of the animation, consisting of 12 frames, in 750 milliseconds.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_size() [1/2]

Glib::PropertyProxy< Gtk::IconSize > Gtk::CellRendererSpinner::property_size | ( |  | ) |

The `Gtk::IconSize` value that specifies the size of the rendered spinner.

Default value: Gtk::IconSize::INHERIT

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_size() [2/2]

Glib::PropertyProxy_ReadOnly< Gtk::IconSize > Gtk::CellRendererSpinner::property_size | ( |  | ) | const

The `Gtk::IconSize` value that specifies the size of the rendered spinner.

Default value: Gtk::IconSize::INHERIT

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

## ◆ wrap()

Gtk::CellRendererSpinner * wrap | ( | GtkCellRendererSpinner * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.